--[[

  ShoutBar by Cilraaz of Archimonde/Cenarion Circle
  v2.4.0-0.1
  
  ShoutBar is a modified version of AspectBar, which creates a row of buttons for a Warrior's shout spells
  
  As stated this is a modified version of AspectBar, by CRiSPyToWN
  
  Change Log:
  v2.4.0-0.1
  -- TOC Update for WoW 2.4
  v2.3.0-0.1
  -- Initial Release
  
]]--


SHOUTBAR_ENABLED = true;

ShoutBarData = { };

local Shouts = {
BATTLE;
DEMO;
COMM;
CHALL;
INTIM;
};

local ShoutIcons = {
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
};

local ver = 23001;

local playerName, vBuffOn, vMounted, button;

function ShoutBar_OnLoad()
	local _, Class = UnitClass("player");
	if (Class == "WARRIOR") then
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("SPELLS_CHANGED");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	
  SLASH_SHOUTBAR1 = "/shoutbar";
	SlashCmdList["SHOUTBAR"] = function(msg)
		ShoutBar_SlashHandler(string.lower(msg));
	end
	end
end

function ShoutBar_SlashHandler(msg)
	if (string.find(msg, "config")) then
		if( ShoutBarConfig:IsVisible() ) then
			ShoutBarConfig:Hide();
		else
			ShoutBarConfig:Show();
		end
	elseif (string.find(msg, "help")) then
		DEFAULT_CHAT_FRAME:AddMessage("To configure type '/shoutbar config'");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Type '/shoutbar help' for help");
	end
  --tinsert(UISpecialFrames,"ShoutBarConfig"); 
end

function StartShoutBar()
	if (not ShoutBarData) then
		ShoutBarData[playerName] = {
			["horizontal"] = "true",
			["battle"] = 1,
			["demo"] = 1,
			["comm"] = 1,
			["chall"] = 1,
			["intim"] = 1,
			["curbar"] = 1,
			["scale"] = 1,
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end
	if (not ShoutBarData[playerName]) then
		ShoutBarData[playerName] = {
			["horizontal"] = "true",
			["battle"] = 1,
			["demo"] = 1,
			["comm"] = 1,
			["chall"] = 1,
			["intim"] = 1,
			["curbar"] = 1,
			["scale"] = 1,
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end 
	SHOUTBAR_SCALE = 1;
	
	ShoutBar_Scale();
	ShoutBar_Update();
end

function FindPattern(text,pattern)
	return string.sub(text, string.find(text, pattern))
end

function ShoutBar_OnEvent()
	if (event == "PLAYER_ENTERING_WORLD") then
		if (UnitName("player") ~= UNKNOWNBEING and UnitName("player") ~= UNKNOWNOBJECT and UnitName("player") and not playerName) then
			playerName = UnitName("player").." of "..GetCVar("realmName");
		end
		StartShoutBar();
	end
	if (event == "SPELLS_CHANGED" or event == "PLAYER_AURAS_CHANGED") then
		ShoutBar_Update();
	elseif (event == "SPELL_UPDATE_COOLDOWN") then
		ShoutBar_UpdateCooldowns();
	end
end

function ShoutBar_Scale()
	for i = 1, 5 do
		button = getglobal("ShoutBarButton"..i);
		button:SetScale(ShoutBarData[playerName]["scale"]);
	end
end

function ShoutBar_O()
	if (ShoutBarData[playerName]) then
		if (not ShoutBarData[playerName]["horizontal"]) then
			ShoutBarData[playerName]["horizontal"] = "true"
			ShoutBarData[playerName]["order"] = "az"			
		end
		
		-- New code for handle
		ShoutBarHandleH:ClearAllPoints();
		ShoutBarHandleH:SetAlpha(0);
		ShoutBarHandleV:ClearAllPoints();
		ShoutBarHandleV:SetAlpha(0);
		
		if (ShoutBarData[playerName]["horizontal"] == "false" and ShoutBarData[playerName]["order"] == "az") then
			for i = 2, 5 do
				local button = getglobal("ShoutBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("TOP", "ShoutBarButton"..i - 1, "BOTTOM", 0, 1);
			end
			ShoutBarHandleH:SetPoint("TOP", "ShoutBarButton1", "TOP", 0, 10);
			ShoutBarHandleH:SetAlpha(1);
		elseif (ShoutBarData[playerName]["horizontal"] == "false" and ShoutBarData[playerName]["order"] == "za") then
			for i = 2, 5 do
				local button = getglobal("ShoutBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("BOTTOM", "ShoutBarButton"..i - 1, "TOP", 0, 1);
			end
			ShoutBarHandleH:SetPoint("BOTTOM", "ShoutBarButton1", "BOTTOM", 0, -10);
			ShoutBarHandleH:SetAlpha(1);
		elseif (ShoutBarData[playerName]["horizontal"] == "true" and ShoutBarData[playerName]["order"] == "az") then
			for i = 2, 5 do
				local button = getglobal("ShoutBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("LEFT", "ShoutBarButton"..i - 1, "RIGHT", 1, 0);
			end
			ShoutBarHandleV:SetPoint("LEFT", "ShoutBarButton1", "LEFT", -10, 0);
			ShoutBarHandleV:SetAlpha(1);
		elseif (ShoutBarData[playerName]["horizontal"] == "true" and ShoutBarData[playerName]["order"] == "za") then
			for i = 2, 5 do
				local button = getglobal("ShoutBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("RIGHT", "ShoutBarButton"..i - 1, "LEFT", 1, 0);
			end
			ShoutBarHandleV:SetPoint("RIGHT", "ShoutBarButton1", "RIGHT", 10, 0);
			ShoutBarHandleV:SetAlpha(1);
		else
			for i = 2, 5 do
				local button = getglobal("ShoutBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("LEFT", "ShoutBarButton"..i - 1, "RIGHT", 1, 0);
			end
			ShoutBarHandleV:SetPoint("LEFT", "ShoutBarButton1", "LEFT", -10, 0);
			ShoutBarHandleV:SetAlpha(1);
		end
	end
end

function ShoutBar_Hide()
   local frame = getglobal("ShoutBar");
   if (frame) then
     if(  frame:IsVisible() ) then
       frame:Hide();
     else
       frame:Show();
     end
   end
end

function ShoutBar_Update()
	if (ShoutBarData[playerName]) then
		ShoutBar_O();
		i = 0;
		if (InCombatLockdown() == nil) then
			for key in pairs(Shouts) do
				getglobal("ShoutBarButton"..key):Hide();
			end
			ShoutBar:Show();
		end
		for key, value in pairs(Shouts) do
			local id = ShoutBar_GetSpellID(value);
			if (id) then
				i = i + 1;
				button = getglobal("ShoutBarButton"..i);
				if (InCombatLockdown() == nil) then
					button:SetAttribute("type", "spell");
					button:SetAttribute("spell", value);
				end
				local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
				getglobal("ShoutBarButton"..i.."Icon"):SetTexture(texture);
				button:SetAttribute("id",id);
				if (InCombatLockdown() == nil) then
					button:Show();
				end
			end
		end
		if ((i == 0) and (InCombatLockdown() == nil)) then
			ShoutBar:Hide();
		end
	end
end

function ShoutBar_UpdateCooldowns()
	for i = 1, 5 do
		button = getglobal("ShoutBarButton"..i);
		if (button:GetAttribute("id")) then
			local cooldown = getglobal(button:GetName().."Cooldown");
			local start, duration, enable = GetSpellCooldown(button:GetAttribute("id"), SpellBookFrame.bookType);
			if (start > 0 and duration > 0) then
				cooldown:SetCooldown(start, duration);
			end
		end
	end
end

function ShoutBar_GetSpellID(spell, rank, debug)
	local i = 1;
	local spellID;
	local highestRank;
	while true do
		local spellName, spellRank = GetSpellName(i, SpellBookFrame.bookType);
		if (not spellName) then
			break;
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					if (debug) then
						DEFAULT_CHAT_FRAME:AddMessage("Found |cffffffff'"..spell.." ("..rank..")'|r at slot |cffffffff'"..i.."'", 0.1, 1.0, 0.0);
					end
					return i;
				end
			else
				spellID = i;
				highestRank = spellRank;
			end
		end
		i = i + 1;
		if (i > 250) then
			break;
		end
	end			
	if (debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Could not find |cffffffff'"..spell.." ("..rank..")'", 1.0, 0.1, 0.0);
	end
	return spellID, highestRank;
end

function ShoutBar_SetTooltip()
	if (this:GetAttribute("id")) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
		GameTooltip:SetSpell(this:GetAttribute("id"), SpellBookFrame.bookType);
		GameTooltip:Show();
	end
end

function ShoutBar_OnClick()
	if (this:GetAttribute("id") and arg1 == "LeftButton") then
		CastSpell(this:GetAttribute("id"), BOOKTYPE_SPELL);
	end
end

function ShoutBar_OnBind(that_spell)
  local spellID = ShoutBar_GetSpellID(that_spell);
	CastSpell(spellID, BOOKTYPE_SPELL);
end

function ShoutBarGetPoint()
	local vLeft = ShoutBar:GetLeft();
	local vTop = ShoutBar:GetTop();
	ShoutBarData[playerName]["left"] = vLeft;
	ShoutBarData[playerName]["top"] = vTop;
	--DEFAULT_CHAT_FRAME:AddMessage(vLeft.." "..vTop);
end


-- CONFIG

-- OnShow
function ShoutBarConfig_OnShow()
	if (not ShoutBarData) then
		this:Hide();
		return;
	end
	if (not ShoutBarData[playerName]) then
		this:Hide();
		return;
	end
	if (not ShoutBarData[playerName]["battle"]) then
		this:Hide();
		return;
	end

	local vSlider = getglobal(this:GetName().."SliderScale");
	vSlider:ClearAllPoints();
	vSlider:SetPoint("TOPLEFT", "ShoutBarConfigCheckButton1", "TOPLEFT", 0, -40);
	
	getglobal(this:GetName().."SliderScale"):SetValue( ShoutBarData[playerName]["scale"] );
	getglobal(this:GetName().."CheckButton1"):SetChecked(ShoutBarData[playerName]["horizontal"]);

end

function ShoutBarConfigScale_OnClick()
	ShoutBarData[playerName]["scale"] = this:GetValue();
	ShoutBar_Scale();
end

function ShoutBarConfigCheckBoxHide_OnClick()
	if (ShoutBarData[playerName]["hidebar"] == "true") then
		ShoutBarData[playerName]["hidebar"] = "false";
	else
		ShoutBarData[playerName]["hidebar"] = "true";
	end
	ShoutBar_Hide();
end

function ShoutBarConfigCheckBox_OnClick()
	if (ShoutBarData[playerName]["horizontal"] == "true") then
		ShoutBarData[playerName]["horizontal"] = "false";
	else
		ShoutBarData[playerName]["horizontal"] = "true"
	end
	ShoutBar_O();
end

function ShoutBarConfigCheckBoxOrder_OnClick()
	if (ShoutBarData[playerName]["order"] == "az") then
		ShoutBarData[playerName]["order"] = "za";
	else
		ShoutBarData[playerName]["order"] = "az"
	end
	ShoutBar_O();
end
